
#include "DIALOG.h"


static const GUI_WIDGET_CREATE_INFO _aDialogCreate[] = {
  { FRAMEWIN_CreateIndirect, "Time setting...",     0,      90,  60, 140, 100, FRAMEWIN_CF_MOVEABLE },
  { TEXT_CreateIndirect,     "00",     GUI_ID_TEXT0,    10,  10, 120,  80 }, 
  { BUTTON_CreateIndirect,   "OK",     GUI_ID_OK,       40, 60,  50,  18 },
};


/*********************************************************************
*
*       _SetFont
*/
static void _SetFont(WM_HWIN hDlg) {
  WM_HWIN hItem;
  int Index;
  hItem = WM_GetDialogItem(hDlg, GUI_ID_RADIO0);
  Index = RADIO_GetValue(hItem);
  hItem = WM_GetDialogItem(hDlg, GUI_ID_TEXT0);
  TEXT_SetFont(hItem, &GUI_FontD32);
}

/*********************************************************************
*
*       _cbCallback
*/
static void _cbCallback(WM_MESSAGE * pMsg) {
  int i;
  int NCode, Id;
  WM_HWIN hDlg, hItem;
  hDlg = pMsg->hWin;
  switch (pMsg->MsgId) {
    case WM_INIT_DIALOG:
      hItem = WM_GetDialogItem(hDlg, GUI_ID_RADIO0);

      _SetFont(hDlg);
      break;
    case WM_NOTIFY_PARENT:
      Id    = WM_GetId(pMsg->hWinSrc);    /* Id of widget */
      NCode = pMsg->Data.v;               /* Notification code */
      switch (NCode) {
      case WM_NOTIFICATION_VALUE_CHANGED: /* Value has changed */
        _SetFont(hDlg);
        break;
      case WM_NOTIFICATION_RELEASED:      /* React only if released */
        if (Id == GUI_ID_OK) {            /* OK Button */
          GUI_EndDialog(hDlg, 0);
        }
        if (Id == GUI_ID_CANCEL) {        /* Cancel Button */
          GUI_EndDialog(hDlg, 1);
        }
        break;
      }
      break;
    default:
      WM_DefaultProc(pMsg);
  }
}


const GUI_ConstString  _apHour[] = {  "00","01","02","03","04","05","06","07","08","09","10","11","12","13","14","15","16","17","18","19","20","21","22","23", 0};

const GUI_ConstString  _apMin[] = {
  "00","01","02","03","04","05","06","07","08","09","10","11","12","13","14","15","16","17","18","19",
  "20","21","22","23","24","25","26","27","28","29","30","31","32","33","34","35","36","37","38","39",
  "40","41","42","43","44","45","46","47","48","49","50","51","52","53","54","55","56","57","58","59",0
};

/*********************************************************************
*
*       Public code
*
**********************************************************************
*/
/*********************************************************************
*
*       MainTask
*/
void MainTask(void) {
  LISTWHEEL_Handle hWin1;   LISTWHEEL_Handle hWin2;   
  int Value1 = 0; int Value2 = 0;
  WM_HWIN hDlgFrame;
  GUI_Init();
GUI_SetBkColor(GUI_BLUE); GUI_Clear();
 // WM_SetCallback(WM_HBKWIN, _cbBkWindow);  
  WM_SetCreateFlags(WM_CF_MEMDEV);  /* Use memory devices on all windows to avoid flicker */
  hDlgFrame = 0;
hWin1= LISTWHEEL_CreateEx( 0, 60, 30, 100, WM_HBKWIN, WM_CF_SHOW, 0, GUI_ID_LISTWHEEL0, _apHour);
hWin2= LISTWHEEL_CreateEx(40, 60, 30, 100, WM_HBKWIN, WM_CF_SHOW, 0, GUI_ID_LISTWHEEL0,_apMin);
LISTWHEEL_SetTextAlign(hWin1, GUI_TA_VCENTER | GUI_TA_HCENTER);
  LISTWHEEL_SetTextAlign(hWin2, GUI_TA_VCENTER | GUI_TA_HCENTER);
  LISTWHEEL_SetSnapPosition(hWin1, 0);
  LISTWHEEL_SetSnapPosition(hWin2, 0);
   LISTWHEEL_SetLineHeight(hWin1, 20);
   LISTWHEEL_SetLineHeight(hWin2, 20);
  LISTWHEEL_SetTextColor(hWin1, LISTWHEEL_CI_SEL, GUI_RED);
   LISTWHEEL_SetTextColor(hWin2, LISTWHEEL_CI_SEL, GUI_RED);
   LISTWHEEL_SetRBorder(hWin1, 00);
   LISTWHEEL_SetRBorder(hWin2, 00);

  while(1) {
    WM_HWIN hDlg, hText;
    char acText[5] = {0};
    GUI_Delay(150);
    
    
    if (!WM_IsWindow(hDlgFrame)) {
      hDlgFrame = GUI_CreateDialogBox(_aDialogCreate, GUI_COUNTOF(_aDialogCreate), &_cbCallback, 0, 0, 0);
    }
    Value1 = LISTWHEEL_GetPos(hWin1); 
    Value2 = LISTWHEEL_GetPos(hWin2); 
    acText[0] = '0' + Value1 / 10;
    acText[1] = '0' + Value1 % 10;   acText[2] = ':';
    acText[3] = '0' + Value2 / 10;
    acText[4] = '0' + Value2 % 10;
    
    
    hDlg = WM_GetClientWindow(hDlgFrame);
    hText = WM_GetDialogItem(hDlg, GUI_ID_TEXT0);
    TEXT_SetText(hText, acText);
  }
}

/*************************** End of file ****************************/

